var intervalId = null;
var framecnt = 0;
const FRAMERATE_5S_5FPS = 25;
const COMMON_ACQUIRED_AUTHENTICATION_ERR =	"<br><br>No image.<br>Authentication error. Camera user name or password isn't correct.";
const COMMON_ACQUIRED_NOT_RECOMMENDED = "（Not a recommended value）";
const COMMON_ACQUIRED_CONNECTING = "<br><br><br>Connecting";
const COMMON_ACQUIRED_NO_IMAGE = "<br><br><br>No image";

var t = [];
//var gsUser = "";
//var gsPass = "";
var gsIpaddress = "";
var gsPortno = "";
var gsUrladdress = "";
var fullurl = "";
var controller = null;
var protocolRadio = document.getElementsByName("cgi_protocol");
var gsProtocol = (protocolRadio[0].checked)?0:1;
var imagewidth = 0;
var imageheight = 0;
var framerate = 0;
// 認証情報
var metaAuthInfo = {};
// CSeq
var metaCseq = 1;
// 定期送信タイマID
var metaTimerId = -1;
// WebSocketオブジェクト
var metaWs;


//ラジオボタン状態設定
protocolRadio[0].onclick=function(){
  if(gsProtocol == 0){return;}
  gsProtocol = 0;
  update_Parameter();
};
protocolRadio[1].onclick=function(){
  if(gsProtocol == 1){return;}
  gsProtocol = 1;
  update_Parameter();
};

//設定値取得
function update_Parameter() {
  var htmladdr="";
  //if(document.getElementById("userText").value != gsUser) {
  //  gsUser = document.getElementById("userText").value;
  //}
  //if(document.getElementById("passText").value != gsPass) {
  //  gsPass = document.getElementById("passText").value;
  //}
  if(document.getElementById("ipAddressText").value != gsIpaddress) {
    gsIpaddress = document.getElementById("ipAddressText").value;
  }
  if(document.getElementById("portNoText").value != gsPortno) {
    gsPortno = document.getElementById("portNoText").value;
  }
  if(document.getElementById("urlAddressText").value != gsUrladdress) {
    gsUrladdress = document.getElementById("urlAddressText").value;
  }
}

// Camera受信を開始する
function metaStart() {
    //中断請求
    if (controller) {
      controller.abort();
      controller = null;
    }
    //初期化
    imagewidth = 0;
    imageheight = 0;
    framerate = 0;
    //画像情報初期表示(Connecting)
    imageInfoDisplayConnecting();
  
    // id,pass
    //gsUser = document.getElementById("userText").value;
    //gsPass = document.getElementById("passText").value;

    // 対象カメラのIPアドレス
    gsIpaddress = document.getElementById("ipAddressText").value;

    //port番号
    gsPortno = document.getElementById("portNoText").value;

    // URL
    gsUrladdress = document.getElementById("urlAddressText").value;

    //FULL URL
    if(gsProtocol == 0){
      document.getElementById("fullURL").innerHTML = 'https://' + gsIpaddress + ':' + gsPortno + '/' + gsUrladdress;
    }else{
      document.getElementById("fullURL").innerHTML = 'http://' + gsIpaddress + ':' + gsPortno + '/' + gsUrladdress;
    }
    fullurl = document.getElementById("fullURL").innerHTML;

    DoLogin();
    getAuthResult();
}

//カメラ登録
function DoLogin() {
  document.getElementById("iframeIpConnect").src = fullurl;
  if (document.getElementById("iframeIpConnect").attachEvent) {
      document.getElementById("iframeIpConnect").attachEvent( "onload" ,  function (){
      //画像情報初期表示
      imageInfoDisplayInit();
      return false;
      });
  } else {
      document.getElementById("iframeIpConnect").addEventListener("load", function () {
      //画像情報初期表示
      imageInfoDisplayInit();
      return false;
      }, false);
  }
  clearInterval(intervalId);
  intervalId = setInterval(getAuthResult, 1000);
}

async function getAuthResult() {
  let image = new Image();
  let w,h;
  image.src = fullurl;
  image.onload = function() {
      imagewidth = image.width;
      imageheight = image.height;
      if(image.width == image.height){
          document.getElementById("jpegfiles").setAttribute('height', '320px');
          document.getElementById("jpegfiles").setAttribute('width', '320x');
      }else {
          document.getElementById("jpegfiles").setAttribute('height', '180px');
          document.getElementById("jpegfiles").setAttribute('width', '320px');
      }
      image.onload = null;
      clearInterval(intervalId);
      getUrlInfo();
  }
}


//画像幅取得
function getUrlInfo() {
    //FPS計算用変数初期化
    var now_time = 0;
    var time_val = 0;
    t.splice(0,t.length);
    framecnt = 0;
    //中断請求
    if (controller) {
      controller.abort();
      controller = null;
    }

    controller = new AbortController();
    var signal = controller.signal;
    //web請求
    fetch(fullurl, { signal }).then((res) => {
        res.headers.forEach(function(val, key) {console.log(key + '->' + val); });
        const reader = res.body.getReader();
        let lineLength = 0;
        let lineBuffer = new Uint8Array(new ArrayBuffer(1000))
        let headers = "";
        let contentLength = -1;
        let contentType = "";
        let imageLength = -1;
        let imageBuffer = null;
        let jsonLength = -1;
        let jsonData = "";
        let bytesRead = 0;
        const read = () => {
          reader.read().then(({done, value}) => {
            if(done) return
            for(let index = 0,len = value.length; index < len; index++) {
              //先读取分段的头部块。按行读取，当数据块长度未有效时，表示正在读取头部块。
              if(contentLength <= 0) {
                lineBuffer[lineLength++] = value[index];
                //每行字符长度最小为2字节。
                if(lineLength < 2) continue;
                //如果行首尾不是\r\n则本行未结束，继续读。
                if(lineBuffer[lineLength - 2] != 0x0d || lineBuffer[lineLength - 1] != 0x0a) continue;
                //成功读取一行，转换为String类型，同时把本行数据拼接到头部的字符串变量中。
                for(let i = 0; i < lineLength; i++){
                  headers += String.fromCharCode(lineBuffer[i])
                }
                //检查本行是否为结束行。当行首为\r\n时头部结束。
                if(lineBuffer[0] === 0x0d && lineBuffer[1] === 0x0a) {
                  //以下是解析头部数据。
                  contentType = getValue(headers, "Content-type");
                  contentLength = getValue(headers, "Content-length");
                  imageLength = getValue(headers, "Content-image-length");
                  jsonLength = getValue(headers, "Content-json-length");
                  imageBuffer = new Uint8Array(new ArrayBuffer(imageLength));
                  //FPS計算
                  now_time = Date.now();
                  if(framecnt > FRAMERATE_5S_5FPS){
                    for(let i=0; i<FRAMERATE_5S_5FPS; i++){
                      t[i] = t[i + 1];
                    }
                    t[FRAMERATE_5S_5FPS] = now_time;
                    time_val = t[FRAMERATE_5S_5FPS] - t[0];
                    framerate = FRAMERATE_5S_5FPS/(time_val/1000);
                  }else{
                    t[framecnt] = now_time;
                    time_val = t[framecnt] - t[0];
                    framerate = framecnt/(time_val/1000);
                    framecnt++;			
                  }                
                  framerate = framerate.toFixed(2);              
                  //document.getElementById("id_framerate").innerHTML = framerate;
                }
                //清空行长度，用于读取下一行。
                lineLength = 0;
              }
              //读取分段的数据块。按数据块的长度读取。
              else if(bytesRead < contentLength) {
                let tempLength = imageLength + jsonLength;
                //先读取图片数据。
                if(bytesRead < imageLength){
                  imageBuffer[bytesRead] = value[index]
                }
                //图片数据后紧接着是json数据。
                else if(bytesRead < tempLength) {
                  jsonData += String.fromCharCode(value[index])
                }
                bytesRead++;
              }else{
                contentLength = 0;
                imageLength = 0;
                jsonLength = 0;
                bytesRead = 0 ;
                headers = '';
                jsonData = '';
                //画像情報表示
                imageInfoDisplayOn();
              }
            }
            read();
          }).catch((error) => {
            console.log("read error", error);
          })
        }
        read();
      }).catch((error) => {
        console.log(error);
      })
}

//解析header部データ
const getValue = (headers, key) => {
    let value = '';
    headers.split("\n").forEach((item) => {
      const itemArr = item.split(":");
      if(itemArr[0] === key) value = itemArr[1];
    })
    if(key.includes('length')) {
      return Number(value);
    }else{
      return value;
    }
  }

//画像情報表示
function imageInfoDisplayOn() {
  if((imagewidth != 0)&&(imageheight != 0))
  {
    document.getElementById("jpegfiles").style.display= "block";
    document.getElementById("jpegfiles").setAttribute('src', fullurl);
    document.getElementById("id_Reimage").style.display= "none";
    document.getElementById("id_Reimage").innerHTML = '';
    
    if (((imagewidth + 'x' + imageheight) != "1920x1080") && ((imagewidth + 'x' + imageheight) != "1280x720") && ((imagewidth + 'x' + imageheight) != "1280x1280")){
      document.getElementById("id_resolution").innerHTML = imagewidth + 'x' + imageheight + COMMON_ACQUIRED_NOT_RECOMMENDED;
    }else{
      document.getElementById("id_resolution").innerHTML = imagewidth + 'x' + imageheight;
    }
    
    if( (framerate < 4) || (framerate > 6)){
      document.getElementById("id_framerate").innerHTML = framerate + COMMON_ACQUIRED_NOT_RECOMMENDED;
    }else{
      document.getElementById("id_framerate").innerHTML = framerate;
    }
  }
}

//画像情報初期表示(init)
function imageInfoDisplayInit() {
  document.getElementById("jpegfiles").style.display= "none";
  document.getElementById("id_Reimage").style.display= "block";
  document.getElementById("id_Reimage").innerHTML = COMMON_ACQUIRED_NO_IMAGE;
  document.getElementById("id_resolution").innerHTML = '-';
  document.getElementById("id_framerate").innerHTML = '-';   
}

//画像情報初期表示(Connecting)
function imageInfoDisplayConnecting() {
  document.getElementById("jpegfiles").style.display= "none";
  document.getElementById("id_Reimage").style.display= "block";
  document.getElementById("id_Reimage").innerHTML = COMMON_ACQUIRED_CONNECTING;
  document.getElementById("id_resolution").innerHTML = '-';
  document.getElementById("id_framerate").innerHTML = '-';   
}

// ハンドラ登録
// ※Chrome拡張機能では、HTMLにて直接onclickを定義することができないため
document.addEventListener('DOMContentLoaded', function() {
  document.getElementById('metaStart').addEventListener('click', metaStart);
});
